#include <math.h>
#include "../melee.h"
#include "../ai.h"

//////////////// States of this AI ///////////////
#define AI_CHASE       1
#define AI_ATTACK      2
//////////////////////////////////////////////////
AI_Player_Chmmr::AI_Player_Chmmr(Ship *ai) :
  AI_Player(ai) {

 select_state = true;
  TractorBeam = false;
}

void AI_Player_Chmmr::calculate() 
{
 AI_Player::calculate(); //Turn off all 'keys'

 if (ai_ship->target==NULL) {
     Stop();
     return;
  }

   switch (state) {
    case AI_CHASE:
                    Chase(ai_ship->target);
                    break;
    case AI_ATTACK:
                    Attack(ai_ship->target);
                    break;
    default: break;
 } 

/// must AI use 'TractorBeam' ////////////
 if (TractorBeam){
  k.fire_special = true;
  if (ai_ship->batt==0) 
   TractorBeam = false;
 }

if (select_state) change_state();

/// must AI use 'TactorBeam' if enemy is near planet?
 double enemy_range=ai_ship->target->distance(spacePlanet);

 if (enemy_range<=300.0){
  double enemy_x=ai_ship->target->normal_x();
  double enemy_y=ai_ship->target->normal_y();
  double planet_x=spacePlanet->normal_x();;
  double planet_y=spacePlanet->normal_y();;
  double ai_x=ai_ship->normal_x();;
  double ai_y=ai_ship->normal_y();;

  if ((enemy_x<=planet_x && enemy_x<=ai_x)||
      (enemy_x>=planet_x && enemy_x>=ai_x))
  if ((enemy_y<=planet_y && enemy_y<=ai_y)||
      (enemy_y>=planet_y && enemy_y>=ai_y))
   k.fire_special = true;
 }
}

void AI_Player_Chmmr::change_state() 
{

double range = ai_ship->distance(ai_ship->target);

 if (range > 400.0 ) {
  state = AI_CHASE;
  if (ai_ship->batt >= int(ai_ship->batt_max / 3.0)) // it's more usefull
   TractorBeam = true;                               // then 'always use'
 } else {
   state = AI_ATTACK;
   TractorBeam = false;
 }

  select_state = false; 
}
